<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="${basePackage!}.dao.${table.entityName!}Repository">
    <resultMap id="BaseResultMap" type="${basePackage!}.entity.${table.entityName}">
    <#list table.columnModels as item>
        <#if item.isKey>
        <id column="${item.colName!}" jdbcType="${item.typeNameUpper}" property="${item.columnNameLowerCamel}"/>
        </#if>
    </#list>

    <#list table.columnModels as item>
        <#if !item.isKey>
        <result column="${item.colName!}" jdbcType="${item.typeNameUpper}" property="${item.columnNameLowerCamel}"/>
        </#if>
    </#list>
    </resultMap>

    <!--<cache type="${r'${corePackag!}'}.util.RedisCache"/>-->
    <select id="query${table.entityName!}s" resultMap="BaseResultMap">
        select * from ${table.tableName}
        where 1=1
        <#if table.idEntity == true>
            <if test="entity.delFlag !=null and entity.delFlag != '' ">
                and del_flag = ${r'#{entity.delFlag}'}
            </if>
            <if test="entity.flag !=null and entity.flag != '' ">
                and flag = ${r'#{entity.flag}'}
            </if>
        </#if>
    </select>

    <select id="query${table.entityName!}sPaged" resultMap="BaseResultMap">
        select * from ${table.tableName}
        where 1=1
        <#if table.idEntity == true>
            <if test="entity.delFlag !=null and entity.delFlag != '' ">
                and del_flag = ${r'#{entity.delFlag}'}
            </if>
            <if test="entity.flag !=null and entity.flag != '' ">
                and flag = ${r'#{entity.flag}'}
            </if>
        </#if>
    </select>
</mapper>