package ${basePackage!}.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.util.CyEpExcelUtil;
import ${basePackage!}.dao.${table.entityName!}Repository;
import ${basePackage!}.entity.${table.entityName!};
import ${basePackage!}.service.${table.entityName!}Service;
import org.rcisoft.core.service.CyBaseService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by ${author!} on ${.now}.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class ${table.entityName!}ServiceImpl extends ServiceImpl<${table.entityName!}Repository,${table.entityName!}>  implements ${table.entityName!}Service {
<#--public class ${table.entityName!}ServiceImpl extends CyBaseService  implements ${table.entityName!}Service {-->

<#--    @Autowired-->
<#--    private ${table.entityName}Repository ${table.entityName?uncap_first}Repository;-->


    /**
    * 保存 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel persist(${table.entityName!} ${table.entityName?uncap_first}){
        //增加操作
        int line = baseMapper.insert(${table.entityName?uncap_first});
<#--        int line = ${table.entityName?uncap_first}Repository.insertSelective(${table.entityName?uncap_first});-->
<#--                CyLogPstUtil.dbInfo(CyUserUtil.getAuthenUsername()+"新增了ID为"+
${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息","新增${table.tableRemark!}");-->
        log.debug(CyUserUtil.getAuthenUsername()+"新增了ID为"+
            ${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息");
        return new CyPersistModel(line);
    }

    /**
    * 删除 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel remove(${table.entityName!} ${table.entityName?uncap_first}){
        int line = baseMapper.realDelete(${table.entityName?uncap_first});
<#--        int line = ${table.entityName?uncap_first}Repository.deleteByPrimaryKey(${table.entityName?uncap_first}.getBusinessId());-->
<#--                CyLogPstUtil.dbInfo(CyUserUtil.getAuthenUsername()+"删除了ID为"+
${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息","删除${table.tableRemark!}");-->
        log.debug(CyUserUtil.getAuthenUsername()+"删除了ID为"+
            ${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息");
        return new CyPersistModel(line);
    }
    <#if table.idEntity == true>
    /**
    * 逻辑删除 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel removeLogical(${table.entityName!} ${table.entityName?uncap_first}){
        ${table.entityName?uncap_first}.setDeleted();
        int line = baseMapper.deleteById(${table.entityName?uncap_first});
<#--        int line = ${table.entityName?uncap_first}Repository.logicalDelete(${table.entityName?uncap_first});-->
    <#--                CyLogPstUtil.dbInfo(CyUserUtil.getAuthenUsername()+"逻辑删除了ID为"+
    ${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息","逻辑删除${table.tableRemark!}");-->
            log.debug(CyUserUtil.getAuthenUsername()+"逻辑删除了ID为"+
                ${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息");
            return new CyPersistModel(line);
        }
    </#if>
    /**
    * 修改 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel merge(${table.entityName!} ${table.entityName?uncap_first}){
    <#--    CyUserUtil.setCurrentMergeOperation(${table.entityName?uncap_first});-->
        int line = baseMapper.updateById(${table.entityName?uncap_first});
<#--        int line = ${table.entityName?uncap_first}Repository.updateByPrimaryKeySelective(${table.entityName?uncap_first});-->
<#--                CyLogPstUtil.dbInfo(CyUserUtil.getAuthenUsername()+"修改了ID为"+${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息","修改${table.tableRemark!}");-->
        log.debug(CyUserUtil.getAuthenUsername()+"修改了ID为"+ ${table.entityName?uncap_first}.getBusinessId()+"的${table.tableRemark!}信息");
        return new CyPersistModel(line);
    }

    /**
    * 根据id查询 ${table.tableRemark!}
    * @param id
    * @return
    */
    @Override
    <#if table.increment == false>
    public ${table.entityName!} findById(String id){
    </#if>
    <#if table.increment == true>
    public ${table.entityName!} findById(int id){
    </#if>
        return baseMapper.selectById(id);
<#--        return ${table.entityName?uncap_first}Repository.selectByPrimaryKey(id);-->
    }

    /**
    * 分页查询 ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Override
    public IPage<${table.entityName!}> findAllByPagination(CyPageInfo<${table.entityName!}> paginationUtility,
<#--    public List<${table.entityName!}> findAllByPagination(CyPageUtil<${table.entityName!}> paginationUtility,-->
        ${table.entityName!} ${table.entityName?uncap_first}){
<#--        <#if table.idEntity == true>-->
<#--        ${table.entityName?uncap_first}.setNormal();-->
<#--        </#if>-->
<#--        return ${table.entityName?uncap_first}Repository.query${table.entityName!}s(${table.entityName?uncap_first});-->
        return baseMapper.query${table.entityName!}sPaged(paginationUtility,${table.entityName?uncap_first});

    }
    /**
    * 查询list ${table.tableRemark!}
    * @param ${table.entityName?uncap_first}
    * @return
    */
    @Override
    public List<${table.entityName!}> findAll(${table.entityName!} ${table.entityName?uncap_first}){
<#--        <#if table.idEntity == true>-->
<#--        ${table.entityName?uncap_first}.setNormal();-->
<#--        </#if>-->
<#--        return ${table.entityName?uncap_first}Repository.query${table.entityName!}s(${table.entityName?uncap_first});-->
        return baseMapper.query${table.entityName!}s(${table.entityName?uncap_first});

    }

    /**
    * 导出${table.tableRemark!}
    * @return
    */
    @Override
    public List<${table.entityName!}> export(${table.entityName!} ${table.entityName?uncap_first}) {
        List<${table.entityName!}> ${table.entityName?uncap_first}List = baseMapper.query${table.entityName!}s(${table.entityName?uncap_first});
        return ${table.entityName?uncap_first}List;
    }

}
